From 9b8f3ea1bb6a21126784cb389b9be5fd36cadef3 Mon Sep 17 00:00:00 2001
From: Pankaj Yadav <pk@videolan.org>
Date: Fri, 4 Feb 2011 02:52:37 +0530
Subject: [PATCH] Symbian Resource Files

---
 .../symbian/resource/backup_registration.xml       |    5 ++
 extras/package/symbian/resource/vlc.rss            |   55 ++++++++++++++++++++
 extras/package/symbian/resource/vlc_reg.rss        |   33 ++++++++++++
 3 files changed, 93 insertions(+), 0 deletions(-)
 create mode 100755 extras/package/symbian/resource/backup_registration.xml
 create mode 100755 extras/package/symbian/resource/vlc.rss
 create mode 100755 extras/package/symbian/resource/vlc_reg.rss

diff --git a/extras/package/symbian/resource/backup_registration.xml b/extras/package/symbian/resource/backup_registration.xml
new file mode 100755
index 0000000..a659213
--- /dev/null
+++ b/extras/package/symbian/resource/backup_registration.xml
@@ -0,0 +1,5 @@
+<?xml version="1.0" standalone="yes"?>
+<backup_registration>
+  <system_backup/>
+  <restore requires_reboot = "no"/>
+</backup_registration>
\ No newline at end of file
diff --git a/extras/package/symbian/resource/vlc.rss b/extras/package/symbian/resource/vlc.rss
new file mode 100755
index 0000000..f3fbb9c
--- /dev/null
+++ b/extras/package/symbian/resource/vlc.rss
@@ -0,0 +1,55 @@
+// *****************************************************************************
+// * vlc.rss: VLC Symbian Application Resource file
+// *****************************************************************************
+// * Copyright © 2010 Pankaj Yadav
+// * Author: Pankaj Yadav
+// * This program is free software; you can redistribute it and/or modify
+// * it under the terms of the GNU General Public License as published by
+// * the Free Software Foundation; either version 2.1 of the License, or
+// * (at your option) any later version.
+// *
+// * This program is distributed in the hope that it will be useful,
+// * but WITHOUT ANY WARRANTY; without even the implied warranty of
+// * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// * GNU General Public License for more details.
+// *
+// * You should have received a copy of the GNU General Public License
+// * along with this program; if not, write to the Free Software
+// * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+// *****************************************************************************/
+
+//  RESOURCE IDENTIFIER
+NAME    AWIZ // 4 letter ID
+
+//  INCLUDES
+#include <eikon.rh>
+#include <avkon.rsg>
+#include <avkon.rh>
+#include <avkon.mbg>
+#include <appinfo.rh>
+
+//  RESOURCE DEFINITIONS
+RESOURCE RSS_SIGNATURE { }
+RESOURCE TBUF { buf="VLC"; }
+
+rls_string STRING_app_caption_string         "VLC"
+rls_string STRING_app_short_caption_string   "VLC"
+
+//----------------------------------------------------
+//
+//    r_VLC_localisable_app_info
+//
+//----------------------------------------------------
+//
+RESOURCE LOCALISABLE_APP_INFO r_VLC_localisable_app_info
+    {
+    short_caption = STRING_app_short_caption_string;
+    caption_and_icon =
+    CAPTION_AND_ICON_INFO
+        {
+        caption         = STRING_app_caption_string;
+        number_of_icons = 1;
+        icon_file       = "\\resource\\apps\\VLC_icon.mif";
+        };
+    }
+// End of File
diff --git a/extras/package/symbian/resource/vlc_reg.rss b/extras/package/symbian/resource/vlc_reg.rss
new file mode 100755
index 0000000..9298628
--- /dev/null
+++ b/extras/package/symbian/resource/vlc_reg.rss
@@ -0,0 +1,33 @@
+// *****************************************************************************
+// * vlc_reg.rss : VLC Symbian Localisable Application Info File
+// *****************************************************************************
+// * Copyright © 2010 Pankaj Yadav
+// * Author: Pankaj Yadav
+// * This program is free software; you can redistribute it and/or modify
+// * it under the terms of the GNU General Public License as published by
+// * the Free Software Foundation; either version 2.1 of the License, or
+// * (at your option) any later version.
+// *
+// * This program is distributed in the hope that it will be useful,
+// * but WITHOUT ANY WARRANTY; without even the implied warranty of
+// * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// * GNU General Public License for more details.
+// *
+// * You should have received a copy of the GNU General Public License
+// * along with this program; if not, write to the Free Software
+// * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+// *****************************************************************************/
+
+#include <appinfo.rh>
+#include <vlc.rsg>
+UID2 KUidAppRegistrationResourceFile
+UID3 0xE80000A8
+
+RESOURCE APP_REGISTRATION_INFO
+  {
+  app_file="vlc";
+  localisable_resource_file = "\\resource\\apps\\VLC";
+  localisable_resource_id   = R_VLC_LOCALISABLE_APP_INFO;
+  embeddability=KAppNotEmbeddable;
+  newfile=KAppDoesNotSupportNewFile;
+  }
-- 
1.7.1